window.addEventListener('load', function () {
  var $ = jQuery;
  console.log('Ready to compile!');
  $('form').each(function () {
    var form = $(this);
    form.find('.babel-compile-source').each(function () {
      var source = $(this);
      var editor = CodeMirror.fromTextArea(this, {
        lineNumbers: true,
        mode: "jsx"
      });  
      var rootName = this.name.slice(0, -8);
      var targets = form.find('*[name="' + rootName + '[compiled]"]');
      form.submit(function (e) {
        try {
          targets.val(Babel.transform(
            editor.getValue(), {
              presets: ['es2015', 'react'],
            }
          ).code);
          console.log('Compiled ' + rootName + '[source] successfully!');
        } catch (err) {
          console.error(err.stack);
          alert('Javascript Error!\n' + err.stack.split('\n').shift() + '\n' + 'Check the Browser Javascript console for more details.');
          e.preventDefault();
        }
      });
    });
  });

  $('.codemirror-html').each(function () {
    CodeMirror.fromTextArea(this, {
      lineNumbers: true,
      mode: "htmlmixed"
    });
  });
});
